UNIT		Intl;

INTERFACE

FUNCTION UCaseIntl(Tkn : Char) : Char;
FUNCTION LCaseIntl(Tkn : Char) : Char;
FUNCTION UCaseStrIntl(s : STRING) : STRING;
FUNCTION LCaseStrIntl(s : STRING) : STRING;

IMPLEMENTATION

FUNCTION UCaseIntl(Tkn : Char) : Char; ASSEMBLER;
	ASM
			MOV	AL, BYTE(Tkn)
			CMP	AL, 'a'					{ char smaller than 'a' ? }
			JB		@no_trans				{ yes, no translation }
			CMP	AL, 'z'					{ char bigger than 'z' ? }
			JA		@special					{ yes, maybe one of the special chars }
			SUB	AL, 'a'-'A'				{ translate lower case to upper case }
@no_trans:
			JMP	@slut						{ pop parameter and return }
@special:
			CLD								{ auto increment for string instructions }
			MOV	DI, OFFSET @Tbl1		{ address of table with special chars }
			MOV	CX, 8						{ length of that table }
			MOV	BX, CS					{ initialize extra segment }
			MOV	ES, BX					{  (table in code segment) }
			REPNE	SCASB						{ character translatable ? }
			JNE	@not_found				{ no, not in table }
			MOV	AL, ES:[DI + 8 - 1]	{ yes, load upper case char }
@not_found:
			JMP	@slut
@Tbl1:	DB		''        { translatable lower case chars }
@Tbl2:	DB		''        { and their upper case versions }
@slut:
	END;

FUNCTION UCaseStrIntl(s : STRING) : STRING;
	VAR
		i	:	BYTE;
	BEGIN
		FOR i := 1 TO LENGTH(s) DO
			s[i] := UCaseIntl(s[i]);
		UCaseStrIntl := s;
	END;

FUNCTION LCaseIntl(Tkn : Char) : Char; ASSEMBLER;
	ASM
			MOV	AL, BYTE(Tkn)
			CMP	AL, 'A'					{ char smaller than 'A' ? }
			JB		@no_trans				{ yes, no translation }
			CMP	AL, 'Z'					{ char bigger than 'z' ? }
			JA		@special					{ yes, maybe one of the special chars }
			ADD	AL, 'a'-'A'				{ translate lower case to upper case }
@no_trans:
			JMP	@slut						{ pop parameter and return }
@special:
			CLD								{ auto increment for string instructions }
			MOV	DI, OFFSET @Tbl1		{ address of table with special chars }
			MOV	CX, 8						{ length of that table }
			MOV	BX, CS					{ initialize extra segment }
			MOV	ES, BX					{  (table in code segment) }
			REPNE	SCASB						{ character translatable ? }
			JNE	@not_found				{ no, not in table }
			MOV	AL, ES:[DI + 8 - 1]	{ yes, load upper case char }
@not_found:
			JMP	@slut
@Tbl1:	DB		''        { translatable upper case chars }
@Tbl2:	DB		''        { and their lower case versions }
@slut:
	END;

FUNCTION LCaseStrIntl(s : STRING) : STRING;
	VAR
		i	:	BYTE;
	BEGIN
		FOR i := 1 TO LENGTH(s) DO
			s[i] := LCaseIntl(s[i]);
		LCaseStrIntl := s;
	END;

BEGIN
END.
