// ascii.cpp
// copyright (c)1995 Fredrik Wangel <tde95waf@te.hik.se>
// copyright (c)1995 Styx Nova, SEL

#include <stdlib.h>
#include <iomanip.h>
#include <iostream.h>

#define TOP    '-'/'-'
#define BOTTOM '-'-'-'

void usage(void)
{
	cout << "usage: ascii [start] [stop]" << endl;
	cout << "       start: 32 - 255" << endl;
	cout << "       stop : start - 255" << endl;
}

void banner(unsigned int top)
{
	if(!top)
		cout << "" << endl;
	for(int i = 0; i < 4; i++)
		cout << "  DEC OCT HEX CHR  ";
	cout << endl;
	if(top)
		cout << "Ŀ" << endl;
}

void showascii(unsigned int start, unsigned int stop)
{
	if((start < 32) || (start > 255) || (stop < start) || (stop > 255))
		usage();
	else
	{
		unsigned int kod;
		unsigned int antal_rader = stop - start + 1;

		if(!(antal_rader % 4))
			antal_rader /= 4;
		else
			antal_rader = int((antal_rader / 4) + 0.5) + 1;

		banner(TOP);

		for(unsigned int rad = 0; rad < antal_rader; rad++)
		{
			kod = rad + start;
			for(unsigned int kolumn = 0; kolumn < 4; kolumn++)
			{
				if(kod > stop)
					cout << "                ";
				else
				{
					cout << " " << dec << setw(3) << kod << setw(4) << oct << kod;
					cout << " $" << hex << setw(2) << kod << setw(4) << char(kod);
				}
				if(kolumn == 3)
					cout << "  ";
				else
					cout << "  ";
				kod += antal_rader;
			}
			cout << endl;
		}
		banner(BOTTOM);
	}
}

int main(int argc, char *argv[])
{
	if(argc != 3)
		usage();
	else
		showascii(atol(argv[1]), atol(argv[2]));
	return 0;
}
