{
	returncodes:
		0         : No error
		1 - 366   : Julian date
		400       : User break
		401       : Invalid date
}

{$M 8192,0,0}
program
	cdate;
uses
	intl,
	nya;
type
	string2		=	string[2];
	string4		=	string[4];
const
	ver			:	string2 = '1';
	rev			:	string2 = '0';
	version		:	string[64] = '$VER: cdate 1.0 (5.8.95) Copyright (C)1995-96 Fredrik Wangel';
	monthl		:	array[1..12] of byte = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	months		:	array[1..12] of string[16] = ('January', 'February', 'Mars', 'April',
															  'May', 'June', 'July', 'August', 'September',
															  'October', 'November', 'December');
	days			:	array[0..6] of string[16] = ('Sunday', 'Monday', 'Tuesday', 'Wednesday',
															  'Thursday', 'Friday', 'Saturday');
	places		:	array[1..31] of string4 = ('st', 'nd', 'rd', 'th', 'th', 'th', 'th', 'th',
															'th', 'th', 'th', 'th', 'th', 'th', 'th', 'th',
															'th', 'th', 'th', 'th', 'st', 'nd', 'rd', 'th',
															'th', 'th', 'th', 'th', 'th', 'th', 'st');
var
	y1,
	m1,
	d1,
	w1,
	j1,
	y2,
	m2				:	word;
	c1,
	c2				:	string;
	int1Bsave	:	pointer;

{$F+}
procedure _break_handler; interrupt;
	begin
		printstr('^C');
		setvector($1B, int1Bsave);
		halt(400);
	end;
procedure XGetDate(var year, mon, day, dow : word); assembler;
	asm
		mov	ah, 42
		int	33
		mov	bx, ax
		les	di, year
		mov	word ptr es:[di], cx
		mov	ax, dx
		and	ax, $ff00
		shr	ax, 8
		les	di, mon
		mov	word ptr es:[di], ax
		mov	ax, dx
		and	ax, $00ff
		les	di, day
		mov	word ptr es:[di], ax
		mov	ax, bx
		and	ax, $00ff
		les	di, dow
		mov	word ptr es:[di], ax
	end;
FUNCTION CursX : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DL
		MOV	AL, DL
	END;
FUNCTION CursY : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DH
		MOV	AL, DH
	END;
function Pad(i : word; j : byte): string4;
	begin
		Pad[0] := chr(j);
		while j > 0 do begin
			Pad[j] := chr(i mod 10 + ord('0'));
			i := i div 10;
			dec(j);
		end;
	end;
function Dig(i : word; j : byte) : string4;
	var
		s				:	string4;
	begin
		str(i, s);
		s := copy(s, length(s) - j + 1, j);
		while ((s[1] = '0') and (length(s) > 1)) do
			delete(s, 1, 1);
		dig := s;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	if paramstr(1) = '/?' then begin
		printstrln('CDate v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('Usage: Cdate [dateformat]');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		printstrln('         CDate v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('');
		printstrln('CDate  returns the  current  date  in a user definable');
		printstrln('format by using combinations of W, V, Y, M, D, P and J');
		printstrln('as well as other characters to personalize the output.');
		printstrln('   %W returns the number of the day in the week (where');
		printstrln('      Sunday  equals  one,   Monday is two  and so on.');
		printstrln('   %V is like the %W  but it has a  "place extension".');
		printstrln('      eg the day 4 gives 4th.');
		printstrln('   %Y returns the last digit of the year. (eg 1995->5)');
		printstrln('  %YY returns the  last two digits,  with zeropadding.');
		printstrln(' %YYY gives you the three last digits, but no padding.');
		printstrln('%YYYY returns  the whole  and unpadded  current  year.');
		printstrln('   %M outputs the month without padding.');
		printstrln('  %MM outputs the month with zeropadding.');
		printstrln(' %MMM returns the name of the month in short form, and');
		printstrln('%MMMM returns the whole name.');
		printstrln('   %D works in the same way as %M. %DD, %DDD and %DDDD');
		printstrln('      are also available.');
		printstrln('   %P is like the %D  but it has a  "place extension".');
		printstrln('      eg the day 23 gives 23rd.');
		printstrln('   %J return the Julian date  (ie the  number of  days');
		printstrln('      since newyear).');
		printstrln('   %% returns the % character.');
		printstrln('You can redirect  the output using the standard MS-DOS');
		printstrln('output redirection character ( > ).  For  instance  to');
		printstrln('output to  the printstrer  you would  type  "CDATE >prn".');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	XGetDate(y1, m1, d1, w1);
	if ((y1 mod 4 = 0) and (frac(y1/100) <> 0.0))
			or ((frac(y1/100) = 0.0) and (y1 mod 400 = 0)) then
		monthl[2] := 29;
	if not ((y1 - 1900) in[80..199]) then begin
		printstrln('Invalid date');
		setvector($1B, int1Bsave);
		halt(401);
	end;
	if not (m1 in[1..12]) then begin
		printstrln('Invalid date');
		setvector($1B, int1Bsave);
		halt(401);
	end;
	if not (d1 in[1..monthl[m1]]) then begin
		printstrln('Invalid date');
		setvector($1B, int1Bsave);
		halt(401);
	end;
	if not (w1 in[0..6]) then begin
		printstrln('Invalid date');
		setvector($1B, int1Bsave);
		halt(401);
	end;
	j1 := 0;
	if m1 > 1 then
		for y2 := 1 to m1 - 1 do
			j1 := j1 + monthl[y2];
	inc(j1, d1);
	if paramcount = 0 then begin
		if cursx <> 1 then
			printstrln('');
		printstrln(pad(d1, 2) + '/' + pad(m1, 2) + '/' + copy(pad(y1, 4), 3, 2));
		setvector($1B, int1Bsave);
		halt(j1);
	end;
	c1 := '';
	y2 := paramcount;
	for m2 := 1 to y2 do
		c1 := c1 + paramstr(m2) + ' ';
	c1[length(c1)] := #3;
	c2 := '';
	y2 := 0;
	repeat
		inc(y2);
		if c1[y2] = '%' then begin;
			c1[y2] := #2;
			if c1[y2 + 1] = '%' then begin
				c2 := c2 + '%';
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 4)) = 'YYYY' then begin
				c2 := c2 + dig(y1, 4);
				delete(c1, y2, 5);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 3)) = 'YYY' then begin
				c2 := c2 + dig(y1, 3);
				delete(c1, y2, 4);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'YY' then begin
				c2 := c2 + copy(pad(y1, 4), 3, 2);
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'Y' then begin
				c2 := c2 + copy(pad(y1, 4), 4, 1);
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 4)) = 'MMMM' then begin
				c2 := c2 + months[m1];
				delete(c1, y2, 5);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 3)) = 'MMM' then begin
				c2 := c2 + copy(months[m1], 1, 3);
				delete(c1, y2, 4);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'MM' then begin
				c2 := c2 + pad(m1, 2);
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'M' then begin
				c2 := c2 + dig(m1, 2);
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 4)) = 'DDDD' then begin
				c2 := c2 + days[w1];
				delete(c1, y2, 5);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 3)) = 'DDD' then begin
				c2 := c2 + copy(days[w1], 1, 3);
				delete(c1, y2, 4);
				dec(y2);
			end
			else
			if ucasestrintl(copy(c1, y2 + 1, 2)) = 'DD' then begin
				c2 := c2 + pad(d1, 2);
				delete(c1, y2, 3);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'D' then begin
				c2 := c2 + dig(d1, 2);
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'P' then begin
				c2 := c2 + dig(d1, 2) + places[d1];
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'W' then begin
				c2 := c2 + dig(w1 + 1, 1);
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'V' then begin
				c2 := c2 + dig(w1 + 1, 1) + places[w1 + 1];
				delete(c1, y2, 2);
				dec(y2);
			end
			else
			if ucasestrintl(c1[y2 + 1]) = 'J' then begin
				c2 := c2 + dig(j1, 3);
				delete(c1, y2, 2);
				dec(y2);
			end;
		end
		else c2 := c2 + c1[y2];
	until c1[y2] = #3;
	c2[0] := chr(ord(c2[0]) - 1);
	if cursx <> 1 then
		printstrln('');
	printstrln(c2);
	setvector($1B, int1Bsave);
	halt(j1);
end.
