{
	returncodes:
		0	:	No error
		1	:  User break
		2	:	File not found
		3	:	Parameter error
		4	:	Maximum position exceeded
}

program
	countx;
uses
	nya,
	dos;
type
	fstyp					=	array[0..63] of byte;
const
	ver					:	string[2] = '1';
	rev					:	string[2] = '0';
	version				:	string[64] = '$VER: countx 1.0 (4.8.95) Copyright (C)1995-96 Fredrik Wangel';
	rot					:	array[1..4] of char = '\|/-';
var
	f						:	file;
	bsf,
	nob,
	s,
	p,
	t,
	i,
	j						:	longint;
	attr,
	l						:	word;
	b						:	byte;
	buf					:	array[1..32768] of byte;
	int1Bsave			:	pointer;
	o						:	boolean;
	sizes					:	array[1..256] of longint;
	sizestr				:	array[1..256] of string[20];
	totsum				:	string[20];
	reminder				:	byte;
	buffer				:	fstyp;

function ExCursYMax(var buffer : fstyp) : byte;
	begin
		asm
			MOV	AH, 1Bh			(* Functionality/State Information *)
			MOV	BX, 0000h
			LES	DI, buffer
			INT	10h
		end;
		ExCursYMax := buffer[34] - 1;
	end;
function CursYMax : byte;
	begin
		CursYMax := ExCursYMax(buffer);
	end;
procedure cursor_on;
	var
		y						:	word;
	begin
		if cursymax > 25 then y := $0806 else y := $100E;
		asm
			mov	ah, 1
			mov	cx, y
			int	16
		end;
	end;
procedure cursor_off;assembler;
	asm
		mov	ah, 1
		mov	cx, $0ffff
		int	16
	end;
{$F+}
procedure _break_handler; interrupt;
	begin
		cursor_off;
		printstrln('^C');
		setvector($1B, int1Bsave);
		if o then begin
			close(f);
			setfattr(f, attr);
		end;
		halt(1);
	end;
{$F-}
function dot(n: longint): string;
	var
		i						:	longint;
		s						:	string;
	begin
		dot := '';
		str(n, s);
		i := length(s);
		if i > 3 then s := copy(s, 1, i - 3) + '.' + copy(s, i - 2, i + 3);
		if i > 6 then s := copy(s, 1, i - 6) + '.' + copy(s, i - 5, i + 6);
		if i > 9 then s := copy(s, 1, i - 9) + '.' + copy(s, i - 8, i + 9);
		dot := s;
	end;

function dots(s: string): string;
	var
		i						:	longint;
	begin
		dots := '';
		i := length(s);
		if i >  3 then s := copy(s, 1, i -  3) + '.' + copy(s, i -  2, i +  3);
		if i >  6 then s := copy(s, 1, i -  6) + '.' + copy(s, i -  5, i +  6);
		if i >  9 then s := copy(s, 1, i -  9) + '.' + copy(s, i -  8, i +  9);
		if i > 12 then s := copy(s, 1, i - 12) + '.' + copy(s, i - 11, i + 12);
		if i > 15 then s := copy(s, 1, i - 15) + '.' + copy(s, i - 14, i + 15);
		if i > 18 then s := copy(s, 1, i - 18) + '.' + copy(s, i - 17, i + 18);
		dots := s;
	end;


begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	o := false;
	if (paramcount = 0) or (paramstr(1) = '/?') then begin
		printstrln('CountX v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('Usage: CountX file [start position] [# bytes to count]');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		printstrln('         CountX v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('');
		printstrln('CountX  outputs  the sum  of all bytes  in a file. The');
		printstrln('number is formatted in the  neat and more  easily read');
		printstrln('x.xxx.xxx fashion.  If the total sum should exceed the');
		printstrln('maximum of 2.147.483.647,  then at the end of program-');
		printstrln('execution,  a calculation  of the file''s sum is given.');
		printstrln('By  putting  a  number  as  the  second  argument  the');
		printstrln('counting starts at that  position in the file.  And by');
		printstrln('entering a third argument  stating the number of bytes');
		printstrln('to include in the count,  it is possible to narrow the');
		printstrln('calculation  to a  portion of  the file  in  question.');
		printstrln('You can redirect  the output using the standard MS-DOS');
		printstrln('output redirection character ( > ).  For  instance  to');
		printstrln('output to another file  you would type  the following:');
		printstrln('"COUNTX command.com >command.cnt".');
		printstrln('');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	nob := 0;
	if paramstr(2) = '' then
		p := 0
	else begin
		val(paramstr(2), p, l);
		if l <> 0 then begin
			printstrln('Error in start position number!');
			halt(3);
		end;
		l := 0;
		if paramstr(3) = '' then
			nob := 0
		else begin
			val(paramstr(3), nob, l);
			if l <> 0 then begin
				printstrln('Error in "bytes to count"!');
				halt(3);
			end;
		end;
		l := 0;
	end;
	if FileExist(paramstr(1)) then begin
		s := 1;
		sizes[s] := 0;
		assign(f, paramstr(1));
		getfattr(f, attr);
		setfattr(f, Archive);
		reset(f, 1);
		o := true;
		if p > 0 then begin
			if (p <= filesize(f)) then
				seek(f, p)
			else begin
				printstrln('Maximum position is ' + dot(filesize(f)));
				halt(4);
			end;
		end;
		bsf := 0;
		p := 0;
		cursor_off;
		repeat
			blockread(f, buf, sizeof(buf), l);
			if l > 0 then begin
				inc(p);
				if p > 4 then p := 1;
				printstr(#13 + rot[p]);
				if nob > 0 then
					if bsf + l > nob then l := abs(nob - bsf);
				for i := 1 to l do begin
					if (MaxLongInt - sizes[s]) > buf[i] then
						inc(sizes[s], buf[i])
					else begin
						inc(s);
						sizes[s] := buf[i];
					end;
					inc(bsf);
				end;
			end;
		until ((l = 0) or ((bsf >= nob) and (nob <> -1)) or (l >= filesize(f)));
		printstr(#13' '#13);
		cursor_on;
		reminder := 0;
		totsum := '';
		t := 0;
		if s > 0 then begin
			for l := 1 to s do str(sizes[l]:20, sizestr[l]);
			totsum := sizestr[1];
			for l := 2 to s do begin
				for j := 20 downto 1 do begin
					reminder := ord(sizestr[l][j]);
					if reminder <> 32 then begin
						reminder := reminder - 48;
						totsum[j] := chr(ord(totsum[j]) + reminder);
						t := j;
						repeat
							reminder := ord(totsum[t]) - 48;
							if reminder > 9 then begin
								totsum[t] := chr(ord(totsum[t]) - 10);
								if totsum[t - 1] = ' ' then
									totsum[t - 1] := '1'
								else
									totsum[t - 1] := chr(ord(totsum[t - 1]) + 1);
							end;
							dec(t);
						until ((reminder < 10) or (t = 1));
					end;
				end;
			end;
			while ((totsum[1] = ' ') and (length(totsum) > 0)) do delete(totsum, 1, 1);
			printstrln(dots(totsum));
		end
		else
			printstrln(dot(sizes[1]));
		close(f);
		setfattr(f, attr);
		o := false;
		setvector($1B, int1Bsave);
		halt(0);
	end
	else begin
		printstrln('File "' + paramstr(1) + '" does not exist.');
		setvector($1B, int1Bsave);
		halt(2);
	end;
end.
