USES
	NYA,
	TPFAST;

CONST
	SECTORS		:	WORD = 64;
	MAXSECT		:	WORD = 1440 * 2;

	ERRMSG		:	ARRAY[1..6] OF STRING =
						('Invalid Format on Disk',
						 'Disk has Read/Write Protection',
						 'Sector Number is Invalid',
						 'Hardware Failure',
						 'BlockWrite() Failed',
						 'No Disk In Drive');
TYPE
	STR12			=	STRING[12];
VAR
	BUF			:	ARRAY[0..32767] OF BYTE;
	FH				:	FILE;
	KEY,
	COUNT,
	RESULT		:	WORD;
	SECT,
	WRITTEN		:	LONGINT;
	NNN			:	INTEGER;

FUNCTION ATOI(S : STRING) : INTEGER;
	VAR
		I,
		J		:	INTEGER;
	BEGIN
		VAL(S, I, J);
		IF J <> 0 THEN I := MAXINT;
		ATOI := I;
	END;

FUNCTION LZ(W : WORD; B : BYTE) : STR12;
	VAR
		S	:	STR12;
	BEGIN
		STR(W : 0, S);
		WHILE LENGTH(S) < B DO S := '0' + S;
		LZ := S;
	END;


BEGIN
	PRINTSTRLN('DSK2IMG v1.00 Copyright (C) 1995-96 Fredrik Wangel, Styx Nova SEL');
	PRINTSTRLN('');
	IF POS('?', PARAMSTR(1)) <> 0 THEN BEGIN
		PRINTSTRLN('Usage: DSK2IMG [nnn]');
		PRINTSTRLN('       nnn defaults to 000. The resulting file will be');
		PRINTSTRLN('       named IMGDSK_A.nnn and over written if existing.');
		HALT(0);
	END;
	NNN := 000;
	IF PARAMCOUNT = 1 THEN NNN := ATOI(PARAMSTR(1));
	PRINTSTR('INSERT DISK IN DRIVE A: AND PRESS ANY KEY WHEN READY...'#13);
	FLUSHKBD;
	REPEAT
	UNTIL KEYHIT;
	CLINE;

	ASSIGN(FH, 'IMGDSK_A.' + LZ(NNN, 3));
	REWRITE(FH, 1);

	WRITTEN := 0;
	SECT := 0;
	REPEAT
		CLINE;
		PRINTSTR(LZ(((MAXSECT DIV 2) - (WRITTEN DIV 1024)), 4) + ' -> ' + LZ((WRITTEN DIV 1024), 4) + ' KB'#13);
		READSECTOR(SEG(BUF), OFS(BUF), 1, SECT, SECTORS);
		IF ERRRETURN <> 0 THEN BEGIN
			IF ERRRETURN = 128 THEN
				ERRRETURN := 6;
			PRINTSTRLN('ERROR: ' + ERRMSG[ERRRETURN]);
			CLOSE(FH);
			HALT(ERRRETURN);
		END;
		INC(SECT, SECTORS);
		BLOCKWRITE(FH, BUF, SIZEOF(BUF), RESULT);
		IF RESULT <> SIZEOF(BUF) THEN BEGIN
			PRINTSTRLN('ERROR: ' + ERRMSG[5]);
			CLOSE(FH);
			HALT(5);
		END;
		INC(WRITTEN, RESULT);
	UNTIL (SECT >= MAXSECT) OR ((GETKEY(KEY) = TRUE) AND (KEY = $011B));
	CLINE;
	IF KEY = $011B THEN
		PRINTSTRLN('ABORTED')
	ELSE
		PRINTSTRLN('OPERATION SUCCESSFUL');
END.
