PROGRAM Free;
{
	HISTORY:

	30.9.95 v1.00 : First version. Bad argument handling and no checking.
	2.10.95 v1.01 : First revision. First public release. Rewritten.
	4.10.95 v1.02 : Second revision. Added BreakHandler. New arguments. Rewrote argument parsing.
	9.1.96  v1.03 : Third revision. Fixed bug in longabr()
}
USES
	NYA,
	CRT,
	DOS;
CONST
	ver		:	BYTE = 1;
	rev		:	BYTE = 2;
	nme		:	STRING[64] = '$VER: free 1.03 (9.1.96) (C)1995-96 Fredrik Wangel (WaF)';
VAR
	showinv	:	BOOLEAN;
	tdsk,
	disks,
	origdir,
	slugg,
	gdtmp		:	STRING[128];
	origtattr,
	drives	:	BYTE;
	du			:	REAL;
	ds,
	df,
	i,
	j			:	LONGINT;
	c			:	ARRAY[1..5] OF BYTE;
	exitsave,
	int1Bsave:	POINTER;

{$F+}
PROCEDURE exitpoint;
	BEGIN
		ExitProc := exitsave;
		SetIntVec($1B, int1Bsave);
		IF (ExitCode <> 0) AND (ErrorAddr <> NIL) THEN BEGIN
			WriteLn;
			TextAttr := $0E;
			WriteLn('Oops! There seems to have been a problem ', ExitCode, ' on exit... Sorry about that.');
			TextAttr := origtattr;
			WriteLn;
			ExitCode := 0;
			ErrorAddr := NIL;
		END;
	END;
{$F+}
PROCEDURE _break_handler; INTERRUPT;
	BEGIN
		ChDir(origdir);
		TextAttr := origtattr;
		Write('^C');
		Halt(1);
	END;
FUNCTION punkt(l : LONGINT) : STRING;
	VAR
		s	:	STRING;
		i	:	INTEGER;
	BEGIN
		Str(l, s);
		i := Length(s) - 2;
		IF Length(s) > 3 THEN
			WHILE i > 1 DO BEGIN
				Insert('.', s, i);
				Dec(i, 3);
			END;
		punkt := s;
	END;
FUNCTION longabr(b2a : LONGINT) : STRING;
	VAR
		b2ar			:	REAL;
		b2as			:	STRING[16];
		abrstr		:	STRING[6];
	BEGIN
		b2ar := b2a;
		abrstr := ' byte';
		IF b2a > ((maxlongint div 2) - 1024*1024*8) THEN BEGIN
			b2ar := b2a / (1024 * 1024 * 1024.0);
			abrstr := 'Gb';
		END
		ELSE IF b2a > ((maxlongint div 2048) - 1024*8) THEN BEGIN
				b2ar := b2a / (1024 * 1024.0);
				abrstr := 'Mb';
			END
			ELSE IF b2a > 1023 THEN BEGIN
					b2ar := b2a / 1024.0;
					abrstr := 'Kb';
				END;
		IF b2a = 0 THEN
			longabr := '0 bytes';
		IF b2a > 0 THEN BEGIN
			IF b2a < 1024 THEN BEGIN
				b2as := punkt(b2a);
			END
			ELSE BEGIN
				if frac(b2ar) >= 0.9 then b2ar := Round(b2ar);
				Str(Round(Frac(b2ar) * 10), b2as);
				if length(b2as) > 1 then
					b2as := b2as[2];
				b2as := punkt(Round(Int(b2ar))) + b2as;
				IF abrstr = ' byte' THEN BEGIN
					IF Length(b2as) > 1 THEN
						b2as[0] := Chr(Ord(b2as[0]) - 1);
				END
				ELSE
					Insert(',', b2as, Length(b2as));
			END;
			b2as := b2as + abrstr;
			longabr := b2as;
		END;
	END;
FUNCTION prc(r : REAL) : STRING;
	VAR
		s	:	STRING;
		i	:	INTEGER;
	BEGIN
		Str(r:3:1, s);
		IF Length(s) < 5 THEN
			FOR i := 1 TO (5 - Length(s)) DO
				s := ' ' + s;
		prc := s;
	END;
FUNCTION stringof(sa: BYTE; sc: CHAR): STRING;
	VAR
		ss				:	STRING;
	BEGIN
		FillChar(ss, SizeOf(ss), sc);
		ss[0] := Chr(sa);
		stringof := ss;
	END;
FUNCTION isdrive(d : BYTE) : INTEGER;
	BEGIN
		{$I-}
		GetDir(d, gdtmp);
		isdrive := IOResult;
		{152 = Drive Not Ready, 15 = Invalid Drive}
	END;


BEGIN
	origtattr := TextAttr;
	c[1] := $02;
	c[2] := $03;
	c[3] := $07;
	c[4] := $04;
	c[5] := $06;
	disks := '';
	j := 0;
	showinv := False;
	FOR i := 1 TO ParamCount DO BEGIN
		slugg := ParamStr(i);
		IF (Pos('?', slugg) <> 0) OR (ucasestr(slugg) = '-H') THEN BEGIN
			WriteLn(Copy(nme, 7, Length(nme)));
			WriteLn('Shows amount of free, total and used space on specified drives.');
			WriteLn;
			WriteLn('Usage: FREE [/HI] [/BW] [/SI] [/ALL] [/A] [/B] [[a:] [b:] ... [z:]]');
			WriteLn;
			WriteLn('If no parameter is given all available drives (except A: and B:) are displayed.');
			WriteLn('/A and /B includes drive A: and B: respectively for scanning.');
			WriteLn('/ALL can be used instead of /A /B.');
			WriteLn('/SI Show Invalid entries too.');
			WriteLn('/BW Uses only lightgray and black for output.');
			WriteLn('/HI Uses lighter colors in the output.');
			WriteLn('Drives to be scanned are stated in the form of a single letter and are');
			WriteLn('separated by a space character. (A to Z only)');
			WriteLn;
			WriteLn('EXAMPLES:');
			WriteLn('FREE /A       scans all available drives except B:');
			WriteLn('FREE a c e d  scans the drives A: C: and E: and D: in that order.');
			WriteLn('FREE q c /si  scans Q: and C: and displays an error if either or');
			WriteLn('              both drives should happen to be inaccessable.');
			WriteLn;
			WriteLn('Send bugreports to: tde95waf@te.hik.se');
			Halt(0);
		END;
		IF ucasestr(slugg) = '/HI' THEN BEGIN
			c[1] := $0A;
			c[2] := $0B;
			c[3] := $0F;
			c[4] := $0C;
			c[5] := $0E;
		END;
		IF ucasestr(slugg) = '/BW' THEN BEGIN
			c[1] := $07;
			c[2] := $07;
			c[3] := $07;
			c[4] := $07;
			c[5] := $07;
		END;
		IF ucasestr(slugg) = '/SI' THEN showinv := True;
		IF ucasestr(slugg) = '/ALL' THEN disks := 'AB' + disks;
		IF ucasestr(slugg) = '/A' THEN disks := 'A' + disks;
		IF ucasestr(slugg) = '/B' THEN disks := 'B' + disks;
		IF Copy(slugg, 1, 1) <> '/' THEN BEGIN
			tdsk := Copy(slugg, 1, 1);
			tdsk := ucasestr(tdsk);
			IF tdsk[1] IN ['A'..'Z'] THEN BEGIN
				IF j = 0 THEN BEGIN
					j := 1;
					disks := '';
				END;
				disks := disks + tdsk;
			END;
		END;
	END;
	GetDir(0, origdir);
	GetIntVec($1B, int1Bsave);
	SetIntVec($1B, Addr(_break_handler));
	exitsave := ExitProc;
	ExitProc := @exitpoint;
	GetDisks(drives);
	IF (drives > 26) THEN BEGIN
		drives := 26;
	END;
	IF j = 0 THEN
		FOR i := 3 TO drives DO
			IF isdrive(i) = 0 THEN disks := disks + Chr(i + 64);
	FOR i := 1 TO Length(disks) - 1 DO BEGIN
		j := i;
		REPEAT
			j := Instr(disks[i], disks, j + 1);
			IF j <> 0 THEN BEGIN
				Delete(disks, j, 1);
			END;
		UNTIL j = 0;
	END;
	Write(#13);
	TextAttr := c[1]; Write  (' DRIVE     FREE SPACE ON DRIVE        TOTAL DRIVE CAPACITY     USAGE ');
	TextAttr :=  $07; WriteLn;
	TextAttr := c[1]; Write  ('');
	FOR i := 1 TO Length(disks) DO BEGIN
		j := isdrive(Ord(disks[i]) - 64);
		IF (j <> 0) AND (showinv = True) THEN BEGIN
			TextAttr :=  $07; WriteLn;
			TextAttr :=  $4E + $80; Write  ('   ', disks[i], '   ');
			TextAttr := c[1]; Write  ('');
			IF j = 152 THEN BEGIN
				TextAttr :=  $4E + $80; Write  ('     DRIVE NOT READY       ');
			END;
			IF j = 15 THEN BEGIN
				TextAttr :=  $4E + $80; Write  ('      INVALID DRIVE        ');
			END;
			TextAttr := c[1]; Write  ('');
			TextAttr :=  $4E + $80; Write  (' INFORMATION NOT AVAILABLE ');
			TextAttr := c[1]; Write  ('');
			TextAttr :=  $4E + $80; Write  ('   N/A  ');
		END;
		IF j = 0 THEN BEGIN
			ds := DiskSize(Ord(disks[i]) - 64);
			df := DiskFree(Ord(disks[i]) - 64);
			du := ((ds - df) / ds) * 100;
			TextAttr :=  $07; WriteLn;
			IF Ord(disks[i]) > 90 THEN BEGIN
				TextAttr := c[2]; Write  ('NetDrv', Chr(Ord(disks[i]) - 26));
			END
			ELSE BEGIN
				TextAttr := c[2]; Write  ('   ', disks[i], '   ');
			END;
			TextAttr := c[1]; Write  ('');
			TextAttr := c[3]; Write  (punkt(df):14);
			TextAttr := c[1]; Write  (' ', stringof(9 - Length(longabr(df)), ' '), '(');
			TextAttr := c[4]; Write  (longabr(df));
			TextAttr := c[1]; Write  (') ');
			TextAttr := c[3]; Write  (punkt(ds):14);
			TextAttr := c[1]; Write  (' ', stringof(9 - Length(longabr(ds)), ' '), '(');
			TextAttr := c[4]; Write  (longabr(ds));
			TextAttr := c[1]; Write  (')  ');
			TextAttr := c[5]; Write  (prc(du):5, '% ');
		END;
	END;
	TextAttr := origtattr;
	WriteLn;
	ChDir(origdir);
END.
