TYPE
	RGB			=	RECORD
							R : Byte;
							G : Byte;
							B : Byte;
						END;
	RGBC			=	RECORD
							R : Byte;
							G : Byte;
							B : Byte;
							C : Byte;
						END;
	VGAPalType	=	ARRAY [0..256] OF RGB;
	IBMPalType	=	ARRAY [0..15] OF RGBC;
CONST
	Colours		:	IBMPalType =
	(                        {NAME       COLOR}
	(R:$00;G:$00;B:$00;C:00),{Black      EGA  0}
	(R:$20;G:$10;B:$00;C:01),{Blue       EGA  1}
	(R:$2A;G:$10;B:$00;C:02),{Green      EGA  2}
	(R:$2A;G:$1A;B:$00;C:03),{Cyan       EGA  3}
	(R:$32;G:$1A;B:$00;C:04),{Red        EGA  4}
	(R:$32;G:$22;B:$00;C:05),{Magenta    EGA  5}
	(R:$36;G:$22;B:$00;C:20),{Brown      EGA 20}
	(R:$2A;G:$1A;B:$00;C:07),{White      EGA  7}
	(R:$20;G:$0A;B:$02;C:56),{Gray       EGA 56}
	(R:$2A;G:$10;B:$0A;C:57),{Lt Blue    EGA 57}
	(R:$2A;G:$1A;B:$0A;C:58),{Lt Green   EGA 58}
	(R:$30;G:$1A;B:$0A;C:59),{Lt Cyan    EGA 59}
	(R:$34;G:$20;B:$0A;C:60),{Lt Red     EGA 60}
	(R:$34;G:$24;B:$0A;C:61),{Lt Magenta EGA 61}
	(R:$3F;G:$24;B:$0A;C:62),{Yellow     EGA 62}
	(R:$3F;G:$2F;B:$1A;C:63) {Br. White  EGA 63}
	);
VAR
	Palette		:	VGAPalType;
	i				:	WORD;

PROCEDURE SetDACs( Fst, NumOfDACs : Word; Pal : Pointer ); ASSEMBLER;
ASM
	PUSH	DS

	MOV	DX, 03C8h				{ PEL address / write }
	MOV	AL, BYTE PTR [Fst]
	OUT	DX, AL
	INC	DX       	       	{ DX --> PEL data     }
	LDS	SI, [Pal]
	XOR	AH, AH
	ADD	SI, AX					{ Adjust address      }
	ADD	SI, AX
	ADD	SI, AX
	MOV	CX, [NumOfDACs]
	MOV	BX, CX
	ADD	CX, BX      	     	{ 3 bytes per color   }
	ADD	CX, BX

@NextC:
	LODSB
	OUT	DX, AL          	 	{ Set DACs }
	LOOP	@NextC

	POP	DS
END;

BEGIN
	RANDOMIZE;
	FOR i := 0 TO 15 DO BEGIN
		Palette[Colours[i].C].R := Colours[i].R;
		Palette[Colours[i].C].G := Colours[i].G;
		Palette[Colours[i].C].B := Colours[i].B;
	END;
	SetDACs(0, 256, @Palette);
END.
