{
	returncodes:
		0         : No error
		1         : User break
		2         : File not found
		3         : Missing argument
		4         : Wildcards in filename
}

{$M 65520,0,0}
program
	whichx;
uses
	dos, nya;
type
	string2				=	string[2];
const
	ver					:	string2 = '1';
	rev					:	string2 = '3';
	version				:	string[64] = '$VER: whichx 1.3 (30.4.96) Copyright (C)1996 Fredrik Wangel';
var
	commandline			:	pathstr;
	int1Bsave			:	pointer;
	parstr1,
	parstr2,
	parstr3				:	string;

{$F+}
procedure _break_handler; interrupt;
	begin
		printstr('^C');
		setvector($1B, int1Bsave);
		halt(1);
	end;
function fixdir(fs:string):string;
	begin
		if length(fs) > 1 then begin
			if fs[length(fs)] <> ':' then begin
				if fs[length(fs)] = '\' then
					fs := copy(fs, 1, length(fs) - 1);
				end
			else
				fs := fs + '\';
		end;
		fixdir := fs;
	end;
function min3(a, b, c : integer) : integer;
	begin
		if(a <= b) then
			b := a;
		if(c <= b) then
			b := c;
		min3 := b;
	end;
function FindIt(cmd : pathstr) : dirstr;
	var
		path,
		path2			:  pathstr;
		pp				:	array[1..3] of pathstr;
		dp,
		dp1,
		dp2,
		dp3			:	dirstr;
		fp,
		fp1,
		fp2,
		fp3			:	namestr;
		ep				:	extstr;
		ii				:	integer;
		aa,
		f1,
		f2,
		f3				:	integer;
	begin
		path := '';
		fsplit(cmd, dp, fp, ep);
		if ((pos('*', cmd) <> 0) or (pos('?', cmd) <> 0)) then begin
			printstrln('No wildcards allowed in filename!');
			setvector($1B, int1Bsave);
			halt(4);
		end;
		path2 := getenv('PATH');

		pp[1] := path2;
		f2 := 0;
		f1 := 1;
		f3 := pos(':.', pp[1]);
		while f3 > 0 do
		begin
			pp[1] := copy(pp[1], f3 - 1, length(pp[1]));
			f1 := f3 - 1;
			f3 := pos(';', pp[1]);
			if f3 > 0 then
				pp[1] := copy(pp[1], 1, f3 - 1)
			else
				f3 := length(path2);

			getdir(0, pp[2]);
			{$I-}
			chdir(pp[1][1] + ':');
			if IOResult <> 0 then
			begin
				pp[1] := path2;
				f2 := f3;
				f3 := pos(':.', pp[1]);
				continue;
			end;
			{$I+}
			delete(path2, f1, f3 - 1);
			pp[1] := fexpand(pp[1]);
			insert(pp[1], path2, f1);
			{$I-}
			chdir(pp[2][1] + ':');
			{$I+}

			pp[1] := path2;
			f2 := f3;
			f3 := pos(':.', pp[1]);
		end;

		if ep = '' then begin

			pp[1] := fexpand(fsearch(fp + '.EXE', path2));
			pp[2] := fexpand(fsearch(fp + '.COM', path2));
			pp[3] := fexpand(fsearch(fp + '.BAT', path2));

			fsplit(pp[1], dp1, fp1, ep);
			fsplit(pp[2], dp2, fp2, ep);
			fsplit(pp[3], dp3, fp3, ep);
			if fp1 = '' then
			begin
				pp[1] := '';
				dp1 := '';
			end;
			if fp2 = '' then
			begin
				pp[2] := '';
				dp2 := '';
			end;
			if fp3 = '' then
			begin
				pp[3] := '';
				dp3 := '';
			end;
			f1 := - pos(fixdir(dp1), path2);
			f2 := - pos(fixdir(dp2), path2);
			f3 := - pos(fixdir(dp3), path2);

			aa := min3(f1, f2, f3);
			if aa = f3 then path := pp[3];
			if aa = f2 then path := pp[2];
			if aa = f1 then path := pp[1];

		end
		else
			path := fsearch(fp + ep, path2);
		if path = '' then begin
			printstrln('"' + ucasestr(fp) + ucasestr(ep) + '" not found in path.');
			setvector($1B, int1Bsave);
			halt(2);
		end;
		path := fexpand(path);
		path := ucasestr(path);
		fsplit(path, dp, fp, ep);
		if (ucasestr(parstr2) = '/K') or (ucasestr(parstr3) = '/K') then begin
			path := fp + ep;
			for ii := 1 to length(path) do
				PutKey(path[ii]);
		end
		else
			printstrln(path);
		if dp = '' then dp := '.';
		if dp[length(dp) - 1] <> ':' then delete(dp, length(dp), 1);
		FindIt := dp;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	if (paramcount = 0) or (paramstr(1) = '/?') then begin
		printstrln('WhichX v' + ver + '.' + rev + ' (C)1996 Fredrik Wangel');
		printstrln('Usage: WhichX file [/C] [/K]');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		PrintStrln('        WhichX v' + ver + '.' + rev + ' (C)1996 Fredrik Wangel');
		PrintStrln('');
		PrintStrln('WhichX  searches  the PATH for the  file  namned file.');
		PrintStrln('If you do  not supply the extension  of the  file then');
		PrintStrln('it will automaticly search for FILE.EXE,  FILE.COM and');
		PrintStrln('then FILE.BAT and show  the complete  path and name of');
		PrintStrln('the one found first.  If the argument /C is present on');
		PrintStrln('the commandline,  then the  current directory  will be');
		PrintStrln('changed to the path of the found file.  If /K is found');
		PrintStrLn('and a file is  found  then its name will be printed at');
		PrintStrLn('the dos prompt instead of on screen only.');
		PrintStrln('You can redirect  the output using the standard MS-DOS');
		PrintStrln('output redirection character ( > ).  For  instance  to');
		PrintStrln('output to the printer you would type "WHICHX ed >prn".');
		PrintStrln('');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	parstr1 := paramstr(1);
	parstr2 := paramstr(2);
	parstr3 := paramstr(3);
	if ucasestr(parstr1) = '/C' then begin
		printstrln('You must supply a filename!');
		setvector($1B, int1Bsave);
		halt(3);
	end;
	commandline := FindIt(parstr1);
	if ucasestr(parstr2) = '/C' then begin
		chdir(commandline);
	end;
	setvector($1B, int1Bsave);
end.
